#pragma once

#ifndef _CIniReader_H_
#define _CIniReader_H_

#include <iostream>
#include <windows.h>
class CIniReader
{
public:
	CIniReader(char* szFileName)
	{
		memset(m_szFileName, 0x00, 255);
		memcpy(m_szFileName, szFileName, strlen(szFileName));
	} 
	int ReadInteger(char* szSection, char* szKey)
	{
		int iDefaultValue = 0;
		int iResult = GetPrivateProfileInt(szSection,  szKey, iDefaultValue, m_szFileName); 
		return iResult;
	}
	float ReadFloat(char* szSection, char* szKey)
	{
		char szResult[255];
		char szDefault[255] = "";
		float fltResult;
		GetPrivateProfileString(szSection,  szKey, szDefault, szResult, 255, m_szFileName); 
		fltResult =  atof(szResult);
		return fltResult;
	}
	bool ReadBoolean(char* szSection, char* szKey)
	{
		char szResult[255];
		char szDefault[255] = "";
		bool bolResult;
		GetPrivateProfileString(szSection, szKey, szDefault, szResult, 255, m_szFileName); 
		bolResult =  (strcmp(szResult, "True") == 0 || strcmp(szResult, "true") == 0) ? true : false;
		return bolResult;
	}
	char* ReadString(char* szSection, char* szKey)
	{
		char* szResult = new char[255];
		char szDefaultValue[255] = "";
		memset(szResult, 0x00, 255);
		GetPrivateProfileString(szSection,  szKey, szDefaultValue, szResult, 255, m_szFileName); 
		return szResult;
	}

	Vec3f ReadVec3f(char* szSection, char* szKey)
	{
		char szResult[255],szDefault[255];
		Vec3f vecResult;
		GetPrivateProfileString(szSection, szKey, szDefault, szResult, 255, m_szFileName);
		vecResult[0]=atof(szResult);
		strcpy(szResult,strchr(szResult,',')+1);
		vecResult[1] = atof(szResult);
		strcpy(szResult,strchr(szResult,',')+1);
		vecResult[2] = atof(szResult);
		return vecResult;
	}
private:
	char m_szFileName[255];
};

#endif // _CIniReader_H_