//makenoise.h

#pragma once

#ifndef _MAKENOISE_H_
#define _MAKENOISE_H_

#include "curlnoise.h"
#include "noise.h"


class MakeNoise: public CurlNoise3
{
public:

	MakeNoise(void);
	Vec3f potential(float x, float y, float z) const;
	void advance_time(float dt);

private:
	float noise0(float x, float y, float z) const { return noise(x, y, z); }
	float noise1(float x, float y, float z) const { return noise(y+31.416f, z-47.853f, x+12.793f); }
	float noise2(float x, float y, float z) const { return noise(z-233.145f, x-113.408f, y-185.31f); }
	
	float distance_and_normal(float x, float y, float z, Vec3f &normal) const;
	void match_boundary(Vec3f &psi, float d, float lengthscale, Vec3f normal) const;
	Vec3f normal(Vec3f u) const;

	void match_sphere(float x, float y, float z, Vec3f &psi, float lengthscale) const;
	void match_cube(float x, float y, float z, Vec3f &psi, float lengthscale) const;
	void match_motion(float x, float y, float z, Vec3f &psi, float lengthscale) const;

	//void project();
	//void initialize(float width,int ni_,int nj_,int nk_);
	//Vec3f get_grid_velocity(const Vec3f& position);
	//template<class S,class T>
	//T interpolate_value(const Vec<3,S>& point, const Array3<T, Array1<T> >& grid);

private:

	std::vector<float> noise_lengthscale;
	std::vector<float> noise_gain;
	FlowNoise3 noise;

	float sphere_radius2;  
	Vec3f sphere_centre2;
	float d0;             //rampеd0
	float d1;
};

#endif // _MAKENOISE_H_
