Vec3f Potential::get_DensityGradient(Vec3f position)
{
	int i,j,k;
	float fx,fy,fz;
	Vec3f gradient;

	get_barycentric(position[0], i, fx, 0, gridX);
	get_barycentric(position[1], j, fy, 0, gridY);
	get_barycentric(position[2], k, fz, 0, gridZ);
	//dx
	float v000 = (density[i+1][j][k] - density[i-1][j][k]) / GRIDL * 0.5f;
	float v001 = (density[i+1][j][k+1] - density[i-1][j][k+1]) / GRIDL * 0.5f;
	float v010 = (density[i+1][j+1][k] - density[i-1][j+1][k]) / GRIDL*0.5f;
	float v011 = (density[i+1][j+1][k+1] - density[i-1][j+1][k+1]) / GRIDL * 0.5f;
	float v100 = (density[i+2][j][k] - density[i][j][k]) / GRIDL * 0.5f;
	float v101 = (density[i+2][j][k+1]-density[i][j][k+1]) / GRIDL * 0.5f;
	float v110 = (density[i+2][j+1][k]-density[i][j+1][k]) / GRIDL * 0.5f;
	float v111 = (density[i+2][j+1][k+1] - density[i][j+1][k+1]) / GRIDL * 0.5f;
	gradient[0]=trilerp(v000, v100, v010, v110, v001, v101, v011, v111, fx, fy, fz);
	//dy
	v000 = (density[i][j+1][k]-density[i][j-1][k])/GRIDL*0.5f;
	v001 = (density[i][j+1][k+1]-density[i][j-1][k+1])/GRIDL*0.5f;
	v010 = (density[i][j+2][k]-density[i][j][k])/GRIDL*0.5f;
	v011 = (density[i][j+2][k+1]-density[i][j][k+1])/GRIDL*0.5f;
	v100 = (density[i+1][j+1][k]-density[i+1][j-1][k])/GRIDL*0.5f;
	v101 = (density[i+1][j+1][k+1]-density[i+1][j-1][k+1])/GRIDL*0.5f;
	v110 = (density[i+1][j+2][k]-density[i+1][j][k])/GRIDL*0.5f;
	v111 = (density[i+1][j+2][k+1]-density[i+1][j][k+1])/GRIDL*0.5f;
	gradient[1]=trilerp(v000, v100,v010, v110, v001, v101,v011, v111,fx, fy, fz);
	//dz
	v000 = (density[i][j][k+1]-density[i][j][k-1])/GRIDL*0.5f;
	v001 = (density[i][j][k+2]-density[i][j][k])/GRIDL*0.5f;
	v010 = (density[i][j+1][k+1]-density[i][j+1][k-1])/GRIDL*0.5f;
	v011 = (density[i][j+1][k+2]-density[i][j+1][k])/GRIDL*0.5f;
	v100 = (density[i+1][j][k+1]-density[i+1][j][k-1])/GRIDL*0.5f;
	v101 = (density[i+1][j][k+2]-density[i+1][j][k])/GRIDL*0.5f;
	v110 = (density[i+1][j+1][k+1]-density[i+1][j+1][k-1])/GRIDL*0.5f;
	v111 = (density[i+1][j+1][k+2]-density[i+1][j+1][k])/GRIDL*0.5f;
	gradient[2]=trilerp(v000, v100,v010, v110, v001, v101,v011, v111,fx, fy, fz);

	return gradient;
}

