#include "objloader.h"

bool IsDebug = false;
//read vertex from file
void objloader::ReadvNodes()
{
	Vec3f tmpNode;
	fscanf(inFile, "%f %f %f", &tmpNode[0], &tmpNode[1], &tmpNode[2]);
	if (maxRadius < tmpNode[0])
		maxRadius = tmpNode[0];
	if (maxRadius < tmpNode[1])
		maxRadius = tmpNode[1];
	if (maxRadius < tmpNode[2])
		maxRadius = tmpNode[2];
	vNodeList.push_back(tmpNode);
	++vNodeNum;
}
//read normalize vertex from file
void objloader::ReadvnNodes()
{
	Vec3f tmpNode;
	fscanf(inFile, "%f %f %f", &tmpNode[0], &tmpNode[1], &tmpNode[2]);
	vnNodeList.push_back(tmpNode);
	++vnNodeNum;
}
//read face from file
void objloader::ReadfNodes()
{
	faceNode tmpfNode;    //½һ
	tmpfNode.fnormal[0] = tmpfNode.fnormal[1] = tmpfNode.fnormal[2] = 0;   //ʼΪ0
	int i = -1;

	char tmpStr[STRINGLEN];
	while (fscanf(inFile,"%s", tmpStr), strstr(tmpStr, "//"))
	{
		v3Node tmpv3Node;   //½һ
		sscanf(tmpStr, "%d//%d", &tmpv3Node.vNum, &tmpv3Node.vnNum);
		tmpv3Node.vNum --;
		tmpv3Node.vnNum --;
		tmpfNode.nodes.push_back(tmpv3Node);

		tmpfNode.fnormal += vnNodeList[tmpv3Node.vnNum];     //ķ߼
	}
	
	fseek(inFile, -1, SEEK_CUR);   //ΪһַfҪǰseekһ
	normalize(tmpfNode.fnormal);   //λ
	fNodeList.push_back(tmpfNode);
	++fNodeNum;
}

//read data from the obj file
bool objloader::ReadObjFromFile(const char * fileName)
{
	if(IsDebug)
		printf("start to read obj from file!\n");

	fopen_s(&inFile, fileName, "r");
	if (!inFile)
		return 0;

	while(fscanf(inFile, "%s", flag) != EOF)
	{
		//printf("%s\n",flag);
		if(strcmp(flag, "v") == 0) {
			ReadvNodes();
		}
		else if(strcmp(flag, "vn") == 0) {
			ReadvnNodes();
		}
		else if (strcmp(flag, "f") == 0) {
			ReadfNodes();
		}
	}
	if(IsDebug)
		printf("finish read obj from file!\n");
	fclose(inFile);
	return 1;
}