#include "app.h"
#include "Horde3D.h"
#include "Horde3DUtils.h"
#include <math.h>
#include <iomanip>
#include <GL\glut.h>
#include <cstdio>
#include <iostream>

using namespace std;
extern FILE *fin, *fout;
#define PARTICLENUM 400

// Ƕת
inline float degToRad( float f ) 
{
	return f * (3.1415926f / 180.0f);
}

GLMmodel* Application::addObj(const char* filename)
{
	GLMmodel* model = glmReadOBJ(filename);
	positionA = Vec3f(model->vertices[3], model->vertices[4],model->vertices[5]);
	//fprintf(fout,"%f %f %f", model->vertices[3], model->vertices[4],model->vertices[5]);
	OBJscale = glmUnitize(model);
	OBJscale *= 10.0f;
	glmScale(model,10.0f);
	positionB = Vec3f(model->vertices[3], model->vertices[4],model->vertices[5]);
	OBJtranslate = positionA - positionB / OBJscale;
	return model;
}

void Application::translateModel(GLMmodel* model, Vec3f p)
{
	for (GLuint i = 1; i <= model -> numvertices; i ++)
	{
		model -> vertices[i * 3] += p[0];
		model -> vertices[i * 3 + 1] += p[1];
		model -> vertices[i * 3 + 2] += p[2];
	}
}

Potential Particle::m_potential = Potential(120, 75, 120);

// ʼ
Application::Application( const std::string &appPath )
{
	for( unsigned int i = 0; i < 320; ++i )
	{	
		_keys[i] = false;
		_prevKeys[i] = false;
	}

	//_x = 95; _y = 5; _z = 5; _rx = 0; _ry = -180; _rz = 0; _velocity = 5.0f;
	_x = -5; _y = 5; _z = 4; _rx = 0; _ry = -90; _rz = 0; _velocity = 5.0f; //
	//_x = 60; _y = 45; _z = 7; _rx = -90; _ry = 180; _rz = 0; _velocity = 5.0f; //
	_curFPS = 30;
	frame = 0;
	display_timestep = 1 / _curFPS;
	simulation_timestep = 0.025;

	_statMode = 0;
	_freezeMode = 0; _debugViewMode = false; _wireframeMode = false;
	_cam = 0;

	_contentDir = appPath + "../Content";

	//=================================================================================

	fin = fopen("swarm.in","r");
	fout = fopen("swarm.out","w");

	//趨ʼĿĵأٶȷΧ¶ȷΧ
	gridX = Particle::m_potential.gridX;
	gridY = Particle::m_potential.gridY;
	gridZ = Particle::m_potential.gridZ;


	//ϵֵdiscomfortֵ
	resetAllGridData();

	Particle::m_potential.SetGoal(50, 55, 6, 10, 50, 55);
	Particle::m_potential.SetSpeedRange(1.5,10.0);
	Particle::m_potential.SetDensityRange(5.0, 30.0);
	Particle::m_potential.SetLamdaWeights(1, 0.6, 0.3, 0.2); //lamdaٶȣʱ䣬Discomfort

	//for (int j = 0 ;j < gridY; j ++)
	//{
	//	for (int i = 0; i < gridX; i ++)
	//		for (int k = 0; k < gridZ; k ++)
	//			fscanf(fin,"%f ",&Particle::m_potential.distance[i][j][k]);
	//}
	//Particle::m_potential.ComputeDiscomfort();

	GLMmodel* cylinder = addObj("resource/bunny.obj");
	moveworld = Vec3f(20, 10, 20);
	translateModel(cylinder,moveworld);
	Particle::m_potential.AddDiscomfort(cylinder);

	//=============================================================================================
}


bool Application::init()
{	
	// Initialize engine
	if( !h3dInit() )
	{	
		h3dutDumpMessages();
		return false;
	}

	//init_day();
	init_lamp();

	//================================
	// Init random generator
	//srand( (unsigned int)time( NULL ) );
	srand( 99777 );  // Use fixed value for better performance comparisons

	//ģͺͶ󶨵horde
	H3DRes characterRes = h3dAddResource( H3DResTypes::SceneGraph, "models/fly/fly.scene.xml", 0 );
	H3DRes characterWalkRes = h3dAddResource( H3DResTypes::Animation, "animations/fly.anim", 0 );
	h3dutLoadResourcesFromDisk( _contentDir.c_str() );


	//ҪĶĺ
	makenoise = new MakeNoise();
	//ô˺ӵ״̬ʼ
	makenoise->seed_particles(particles, PARTICLENUM);

	//H3DRes cubeRes = h3dAddResource( H3DResTypes::SceneGraph, "models/cube/cube.scene.xml", 0 );
	//h3dutLoadResourcesFromDisk( _contentDir.c_str() );
	//int num = 0;
	//vector<H3DNode> cube;
	//for (int i = 0; i < gridX; i ++)
	//	for (int j = 0; j < gridY; j ++)
	//		for (int k = 0; k < gridZ; k ++)
	//		{
	//			if (Particle::m_potential.m_gridData[i][j][k].discomfort > 0) //˵ڱ߽
	//			{
	//				cube.push_back(h3dAddNodes( H3DRootNode, cubeRes ));
	//				h3dSetNodeTransform( cube[num], i * GRIDL, j * GRIDL, k * GRIDL, 0, 0, 0, GRIDL, GRIDL, GRIDL );
	//				num ++;
	//			}
	//		}
	for (iterator i = particles.begin(); i != particles.end(); i ++)
	{
		(*i).getVelocity();
		// Add character to scene and apply animation
		//ӵhorde3dĶ
		(*i).node = h3dAddNodes( H3DRootNode, characterRes );
		//Ӹ趯
		//ʼһֵʾ
		h3dSetupModelAnimStage( (*i).node, 0, characterWalkRes, 0, "", false );
		(*i).animTime = rand() % 60;

		//ӵĵǰλ
		//Ҫת
		h3dSetNodeTransform( (*i).node, (*i).Position[0], (*i).Position[1], (*i).Position[2], 0, 0, 0, 0.3, 0.3, 0.3);
	}

	//ܳ
	Particle::m_potential.ComputeFaceData();
	Particle::m_potential.FMM();
	return true;
}

void Application::reset()
{
	//_x = -5; _y = 5; _z = 4; _rx = 0; _ry = -90; _rz = 0; _velocity = 5.0f; //
	//_x = 5; _y = 25; _z = 7; _rx = -90; _ry = -135; _rz = 0; _velocity = 5.0f; //

	makenoise->reset_particles(particles, PARTICLENUM);

	for (iterator i = particles.begin(); i != particles.end(); i ++)
	{
		(*i).getVelocity();
		h3dSetNodeTransform( (*i).node, (*i).Position[0], (*i).Position[1], (*i).Position[2], 0, 0, 0, 0.3, 0.3, 0.3);
	}

	//for (iterator i = particles.begin(); i != particles.end(); i++)
	//	(*i).updateDensity();

	//for(int x = 0; x < gridX; x ++)
	//	for (int y = 0; y < gridY; y ++)
	//		for(int z = 0; z < gridZ; z++)
	//			if(Particle::m_potential.density[x][y][z] > 0) 
	//				Particle::m_potential.averagev[x][y][z] = Particle::m_potential.averagev[x][y][z] / Particle::m_potential.density[x][y][z];

}

//updateÿһ֡λá
void Application::update(float fps)
{
	if( ! _freezeMode )
	{
		//if (_x < 26) _x += 0.1;
		//if (_z < 26) _z += 0.1;
		//---------------------begin---------continuum crowds㷨----------------------------------

		//ۼƼTotalDataеܶȺٶ section4.1е㷨
		for (iterator i = particles.begin(); i != particles.end(); i++)
			(*i).updateDensity();

		//for(int x = 0; x < gridX; x ++)
		//	for (int y = 0; y < gridY; y ++)
		//		for(int z = 0; z < gridZ; z++)
		//			if(Particle::m_potential.density[x][y][z] > 0) 
		//				Particle::m_potential.averagev[x][y][z] = Particle::m_potential.averagev[x][y][z] / Particle::m_potential.density[x][y][z];

		//ܳ
		//Particle::m_potential.ComputeFaceData();
		//Particle::m_potential.FMM();

		//---------------------end-----------continuum crowds㷨----------------------------------

		Vec3f midx;
		//for( unsigned int j = tracelength - 1; j > 0; -- j )
		//	_particles[j] = _particles[j-1];

		display_timestep = 1 / fps;
		int i;
		//ӵٶֵӵĵǰλãnoise_velocity
		for (i = 0; i != particles.size(); i ++)
		{
			particles[i].forward = Vec3f(particles[i].Position);
			// almost RK2 (not updating t halfway through time step, so it's technically only 1st order accurate)
			makenoise -> get_velocity( particles[i].Position, particles[i].noise_velocity );
			particles[i].getGlobalVelocity(particles[i].Position);
			midx =particles[i].Position + 0.5f * display_timestep * particles[i].getVelocity();

			makenoise -> get_velocity( midx, particles[i].noise_velocity );
			particles[i].getGlobalVelocity(midx);

			particles[i].Position += display_timestep * particles[i].getVelocity();
			particles[i].forward = Vec3f(particles[i].Position - particles[i].forward);
			//normalize(particles[i].forward);
		}

		//ײ Чʺܵͣ
		for (i = 0; i != particles.size(); i ++)
			for (int j = i + 1; j != particles.size(); j ++)
			{
				float d = dist(particles[i].Position,particles[j].Position);
				if (d < (particles[i].radius+particles[j].radius))
				{
					Vec3f fij = particles[i].Position - particles[j].Position;
					Vec3f adjust = normalized(fij) * (particles[i].radius + particles[j].radius);
					adjust = (adjust - fij) / 2.0;
					particles[i].Position -= adjust;
					particles[j].Position += adjust;						
				}
			}

			//fprintf(fout, "frame #%d:\n",frame ++);
			for (i = 0; i != particles.size(); i ++)
			{
				float matrix1[4][4] = {{1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1}};
				float matrix2[4][4] = {{1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1}};
				float x = particles[i].forward[0], y = particles[i].forward[1], z = particles[i].forward[2];
				float d = sqrt(x*x+y*y+z*z);

				if (d > 0.000001) //Ϊ0κβ
				{
					x = x/d;
					y = y/d;
					z = z/d;

					d = sqrt(x*x+z*z);
					if (d > 0.000001)
					{
						float cosbeta =x/d, sinbeta = z/d ;

						//matrix1[4][4]ĳͷxᣬΪyϵyתbetaǶȡbetaxyzxozƽϵͶӰx֮ļн
						matrix1[0][0] = cosbeta;
						matrix1[0][2] = sinbeta;
						matrix1[2][0] = -sinbeta;
						matrix1[2][2] = cosbeta;
					}

					//matrix2[4][4]ʼΪλȻΪxyz루xyzxozƽϵͶӰĲˣע˳򣡣
					//ͷȥʱתxyzxozƽϵͶӰ루xyz֮ĽǶtheta
					if (x == 0 && z == 0)
					{
						Rotate(0,1,0,0,-y/abs(y),matrix2);
					}
					else
					{
						float nx = y * z ,ny = 0,nz = - x * y;
						d = sqrt(nx*nx+ny*ny+nz*nz);

						if (d > 0.000001)
						{
							nx = nx/d;
							ny = ny/d;
							nz = nz/d;
							float costheta=sqrt(x*x+z*z), sintheta = abs(y);
							Rotate(costheta, sintheta, nx, ny, nz, matrix2);
						}
					}
				}

				float matrix[4][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}};
				float matrix3[4][4] = {{0.3,0,0,0},{0,0.3,0,0},{0,0,0.3,0},{0,0,0,1}};
				float matrix4[4][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}};;
				Muti(matrix4,matrix3,matrix1);
				Muti(matrix, matrix4, matrix2);

				matrix[3][0] = particles[i].Position[0], matrix[3][1] = particles[i].Position[1], matrix[3][2] = particles[i].Position[2];
				const float * point = (const float *)matrix;
				h3dSetNodeTransMat(particles[i].node, point);
	
				particles[i].animTime += 1.8f;  
				h3dSetModelAnimParams( particles[i].node, 0, particles[i].animTime, 1.0f );
			
				//Vec3f tmp = (particles[i].Position - moveworld) / OBJscale + OBJtranslate;
				//fprintf(fout,"%f %f %f %f %f %f\n",tmp[0], tmp[1], tmp[2], particles[i].forward[0], particles[i].forward[1], particles[i].forward[2]);
			}
			//fprintf(fout, "\n");
			//psi
			makenoise -> advance_time( simulation_timestep );
	}
}

void Application::Muti( float matrix[4][4], float matrix1[4][4], float matrix2[4][4])
{

	for (int i = 0; i < 4; i ++)
		for (int j = 0; j < 4; j ++)
			for (int k = 0; k < 4; k ++)
				matrix[i][j] += matrix1[i][k] * matrix2[k][j];
	return;
}
void Application::Rotate( float costheta, float sintheta, float nx, float ny, float nz, float matrix[4][4] )
{
	//nx,ny,nzΪ n׼
	//matrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1); //ʼ

	matrix[0][0] = nx * nx * ( 1 - costheta ) + costheta;
	matrix[0][1] = nx * ny * ( 1 - costheta ) - nz * sintheta;
	matrix[0][2] = nx * nz * ( 1 - costheta ) + ny * sintheta;
	matrix[1][0] = nx * ny * ( 1 - costheta ) + nz * sintheta;
	matrix[1][1] = ny * ny * ( 1 - costheta ) + costheta;
	matrix[1][2] = ny * nz * ( 1 - costheta ) - nx * sintheta;
	matrix[2][0] = nx * nz * ( 1 - costheta ) - ny * sintheta;
	matrix[2][1] = ny * nz * ( 1 - costheta ) + nx * sintheta;
	matrix[2][2] = nz * nz * ( 1 - costheta ) + costheta;  
	return;
}

void Application::resetAllGridData(void)
{
	for(int x = 0; x < gridX; x ++)
		for (int y = 0; y < gridY; y ++)
			for(int z = 0; z < gridZ; z ++)
			{
				Particle::m_potential.density[x][y][z] = 0;
				Particle::m_potential.averagev[x][y][z] = Vec3f(0,0,0);
				Particle::m_potential.m_gridData[x][y][z].discomfort = 0;
			}

}


void Application::init_lamp()
{	
	// Set options
	h3dSetOption( H3DOptions::LoadTextures, 1 );
	h3dSetOption( H3DOptions::TexCompression, 0 );
	h3dSetOption( H3DOptions::MaxAnisotropy, 4 );
	h3dSetOption( H3DOptions::ShadowMapSize, 2048 );
	h3dSetOption( H3DOptions::FastAnimation, 1 );

	// Add resources Щòʡƹ⡢ʾģʽȣԲø
	// Pipelines
	_forwardPipeRes = h3dAddResource( H3DResTypes::Pipeline, "pipelines/forward.pipeline.xml", 0 );
	_deferredPipeRes = h3dAddResource( H3DResTypes::Pipeline, "pipelines/deferred.pipeline.xml", 0 );
	// Overlays
	_fontMatRes = h3dAddResource( H3DResTypes::Material, "overlays/font.material.xml", 0 );
	_panelMatRes = h3dAddResource( H3DResTypes::Material, "overlays/panel.material.xml", 0 );
	// Shader for deferred shading
	H3DRes lightMatRes = h3dAddResource( H3DResTypes::Material, "materials/light.material.xml", 0 );
	// Environment
	H3DRes envRes = h3dAddResource( H3DResTypes::SceneGraph, "models/platform/platform.scene.xml", 0 );
	H3DRes countrysceneRes = h3dAddResource( H3DResTypes::SceneGraph, "models/bunny/bunny.scene.xml", 0 );\
	H3DRes axisRes = h3dAddResource( H3DResTypes::SceneGraph, "models/axis/axis.scene.xml", 0 );
	// Skybox
	H3DRes skyBoxRes = h3dAddResource( H3DResTypes::SceneGraph, "models/sky02/sky02.scene.xml", 0 );
	// Load resources
	h3dutLoadResourcesFromDisk( _contentDir.c_str() );

	// Add scene nodes
	// Add camera
	_cam = h3dAddCameraNode( H3DRootNode, "Camera", _forwardPipeRes );
	//h3dSetNodeParamI( _cam, H3DCamera::OccCullingI, 1 );

	// Add environment
	H3DNode env = h3dAddNodes( H3DRootNode, envRes );
	h3dSetNodeTransform( env, 0, 0, 0, 0, 0, 0, 2.0f, 2.0f, 2.0f );
	H3DNode axis = h3dAddNodes( H3DRootNode, axisRes );
	h3dSetNodeTransform(  axis, 0, 0, 0, 0, 0, 0, 1, 1, 1 );
	H3DNode countryscene = h3dAddNodes( H3DRootNode, countrysceneRes );
	h3dSetNodeTransform( countryscene, moveworld[0], moveworld[1], moveworld[2], 0, 0, 0, 1, 1, 1 );


	// Add skybox
	H3DNode sky = h3dAddNodes( H3DRootNode, skyBoxRes );
	h3dSetNodeTransform( sky, 0, 0, 0, 0, 0, 0, 0.1, 0.1, 0.1 );
	h3dSetNodeFlags( sky, H3DNodeFlags::NoCastShadow, true );

	// Add light source
	//ģ䣬棬ϿգǶ180ȣûӰ
	H3DNode light0 = h3dAddLightNode( H3DRootNode, "Light0", lightMatRes, "LIGHTING", "SHADOWMAP" );
	h3dSetNodeTransform(light0, 0, 80, 0, -90, 0, 0, 1, 1, 1 );  //߶80ģ͵ĴС
	h3dSetNodeParamF( light0, H3DLight::RadiusF, 0, 200 );
	h3dSetNodeParamF( light0, H3DLight::FovF, 0, 270 );
	h3dSetNodeParamI( light0, H3DLight::ShadowMapCountI, 0 );
	h3dSetNodeParamF( light0, H3DLight::ShadowSplitLambdaF, 0, 0.5f );
	h3dSetNodeParamF( light0, H3DLight::ShadowMapBiasF, 0, 0.001f );
	h3dSetNodeParamF( light0, H3DLight::ColorF3, 0, 0.5f );
	h3dSetNodeParamF( light0, H3DLight::ColorF3, 1, 0.5f );
	h3dSetNodeParamF( light0, H3DLight::ColorF3, 2, 0.5f );

	H3DNode light1 = h3dAddLightNode( H3DRootNode, "Light1", lightMatRes, "LIGHTING", "SHADOWMAP" );
	h3dSetNodeTransform(light1, -5, 15, -5, -45, 225, 0, 1, 1, 1 );  
	h3dSetNodeParamF( light1, H3DLight::RadiusF, 0, 50 );
	h3dSetNodeParamF( light1, H3DLight::FovF, 0, 150 );
	h3dSetNodeParamI( light1, H3DLight::ShadowMapCountI, 3 );
	h3dSetNodeParamF( light1, H3DLight::ShadowSplitLambdaF, 0, 0.9f );
	h3dSetNodeParamF( light1, H3DLight::ShadowMapBiasF, 0, 0.001f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 0, 1.0f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 1, 1.0f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 2, 1.0f );

}


//ȾԲø
void Application::mainLoop( float fps )
{
	_curFPS = fps;

	h3dSetOption( H3DOptions::DebugViewMode, _debugViewMode ? 1.0f : 0.0f );
	h3dSetOption( H3DOptions::WireframeMode, _wireframeMode ? 1.0f : 0.0f );

	if( !_freezeMode )
	{
		update( _curFPS );
	}

	// Set camera parameters
	h3dSetNodeTransform( _cam, _x, _y, _z, _rx ,_ry, _rz, 1, 1, 1 );

	// Show stats
	h3dutShowFrameStats( _fontMatRes, _panelMatRes, _statMode );
	if( _statMode > 0 )
	{
		if( h3dGetNodeParamI( _cam, H3DCamera::PipeResI ) == _forwardPipeRes )
			h3dutShowText( "Pipeline: forward", 0.03f, 0.24f, 0.026f, 1, 1, 1, _fontMatRes );
		else
			h3dutShowText( "Pipeline: deferred", 0.03f, 0.24f, 0.026f, 1, 1, 1, _fontMatRes );
	}

	// Render scene
	h3dRender( _cam );

	// Finish rendering of frame
	h3dFinalizeFrame();

	// Remove all overlays
	h3dClearOverlays();

	// Write all messages to log file
	h3dutDumpMessages();
}

void Application::release()
{
	delete makenoise; 
	makenoise = 0x0; 

	//for (iterator i = particles.begin(); i != particles.end(); i ++)
	//	delete(i);
	particles.clear();

	// Release engine
	h3dRelease();
}


void Application::resize( int width, int height )
{
	// Resize viewport
	h3dSetNodeParamI( _cam, H3DCamera::ViewportXI, 0 );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportYI, 0 );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportWidthI, width );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportHeightI, height );

	// Set virtual camera parameters
	h3dSetupCameraView( _cam, 45.0f, (float)width / height, 0.1f, 1000.0f );
	h3dResizePipelineBuffers( _deferredPipeRes, width, height );
	h3dResizePipelineBuffers( _forwardPipeRes, width, height );
}

void Application::keyStateHandler()
{
	// ----------------
	// Key-press events
	// ----------------
	if( _keys[32] && !_prevKeys[32] )  // Space
	{
		if( ++_freezeMode == 3 ) _freezeMode = 0;
	}

	if( _keys[260] && !_prevKeys[260] )  // F3
	{
		if( h3dGetNodeParamI( _cam, H3DCamera::PipeResI ) == _forwardPipeRes )
			h3dSetNodeParamI( _cam, H3DCamera::PipeResI, _deferredPipeRes );
		else
			h3dSetNodeParamI( _cam, H3DCamera::PipeResI, _forwardPipeRes );
	}

	if( _keys[264] && !_prevKeys[264] )  // F7
		_debugViewMode = !_debugViewMode;

	if( _keys[265] && !_prevKeys[265] )  // F8
		_wireframeMode = !_wireframeMode;

	if( _keys[263] && !_prevKeys[263] )  // F6
	{
		_statMode += 1;
		if( _statMode > H3DUTMaxStatMode ) _statMode = 0;
	}
    //===================================================
	if (_keys[261] && !_prevKeys[261])  //F4
	{
		reset();
	}

	// --------------
	// Keya----------
	if( _freezeMode != 2 )
	{
		float curVel = _velocity / _curFPS;

		if( _keys[287] ) curVel *= 5;	// LShift

		if( _keys['W'] )
		{
			// Move forward
			_x -= sinf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
			_y -= sinf( -degToRad( _rx ) ) * curVel;
			_z -= cosf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
		}
		if( _keys['S'] )
		{
			// Move backward
			_x += sinf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
			_y += sinf( -degToRad( _rx ) ) * curVel;
			_z += cosf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
		}
		if( _keys['A'] )
		{
			// Strafe left
			_x += sinf( degToRad( _ry - 90) ) * curVel;
			_z += cosf( degToRad( _ry - 90 ) ) * curVel;
		}
		if( _keys['D'] )
		{
			// Strafe right
			_x += sinf( degToRad( _ry + 90 ) ) * curVel;
			_z += cosf( degToRad( _ry + 90 ) ) * curVel;
		}
	}
}


void Application::mouseMoveEvent( float dX, float dY )
{
	if( _freezeMode == 2 ) return;

	// Look left/right
	_ry -= dX / 100 * 30;

	// Loop up/down but only in a limited range
	_rx += dY / 100 * 30;
	if( _rx > 90 ) _rx = 90; 
	if( _rx < -90 ) _rx = -90;
}
