//Potential.cpp 
#include "Potential.h"
#include "interp.h"
#include <cmath>

Potential::Potential(int x, int y, int z, float maxd, float mind, float _lamda, float m1, float m2, float m3)
{
	gridX = x;
	gridY = y;
	gridZ = z;
	//ratio = ((float)MAXgridX)/gridX;

	maxDensity = maxd;
	minDensity = mind;
	lamda = _lamda;
	w1 = m1;
	w2 = m2;
	w3 = m3;
	sum_index = 0;
	sum_num = 0;
}

void Potential::SetGoal(int xa,int xb,int za,int zb)
{
	m_GoalXa = xa;
	m_GoalXb = xb;
	m_GoalZa = za;
	m_GoalZb = zb;
}

void Potential::SetSpeedRange(float minSpeed, float maxSpeed)
{
	m_maxSpeed = maxSpeed;
	m_minSpeed = minSpeed;
}

void Potential::SetSlopeRange(float maxSlope, float minSlope)
{
	m_maxSlope = maxSlope;
	m_minSlope = minSlope;
}

//void Potential::ComputeFaceData(TotalDataStruct & TotalData)
//{
//	//dHeight
//	for(int m=0;m<MAXgridX/*gridX*/;m++)
//		for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//		{
//			if(m+1<MAXgridX/*gridX*/)
//				m_gridData[m][n].faceData[0].dheight = TotalData.height[m][n] - TotalData.height[m+1][n];
//			if(n+1<MAXgridZ/*gridZ*/)
//				m_gridData[m][n].faceData[1].dheight = TotalData.height[m][n] - TotalData.height[m][n+1];
//			if(m-1>=0)
//				m_gridData[m][n].faceData[2].dheight = TotalData.height[m][n] - TotalData.height[m-1][n];
//			if(n-1>=0)
//				m_gridData[m][n].faceData[3].dheight = TotalData.height[m][n] - TotalData.height[m][n-1];
//		}
//
//		for(int m=0;m<MAXgridX/*gridX*/;m++)
//			for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//			{
//				if(m+1<MAXgridX/*gridX*/)
//				{
//					float speedT;
//					if(m_gridData[m][n].faceData[0].dheight<m_maxSlope
//						||m_gridData[m][n].faceData[0].dheight>m_minSlope)
//						speedT = 0;
//					else speedT = m_maxSpeed + (m_gridData[m][n].faceData[0].dheight-m_minSlope)
//						/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//					float speedV =  TotalData.averagev[m+1][n].x;
//					if(speedV<0) speedV = 0;
//					if(speedV>speedT) speedV=speedT;
//					if(TotalData.density[m+1][n]<=minDensity)
//					{
//						m_gridData[m][n].faceData[0].speed = speedT;
//					}
//					else if(TotalData.density[m+1][n]>=maxDensity)
//					{
//						m_gridData[m][n].faceData[0].speed = speedV;
//					}
//					else
//					{
//						m_gridData[m][n].faceData[0].speed = speedT + (TotalData.density[m+1][n]-minDensity)
//							/(maxDensity-minDensity)*(speedV-speedT);
//					}
//
//				}
//				if(n+1<MAXgridZ/*gridZ*/)
//				{
//					float speedT;
//					if(m_gridData[m][n].faceData[1].dheight<m_maxSlope
//						||m_gridData[m][n].faceData[1].dheight>m_minSlope)
//						speedT = 0;
//					else speedT = m_maxSpeed + (m_gridData[m][n].faceData[1].dheight-m_minSlope)
//						/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//					float speedV =  TotalData.averagev[m][n+1].z;
//					if(speedV<0) speedV = 0;
//					if(speedV>speedT) speedV=speedT;
//					if(TotalData.density[m][n+1]<=minDensity)
//					{
//						m_gridData[m][n].faceData[1].speed = speedT;
//					}
//					else if(TotalData.density[m][n+1]>=maxDensity)
//					{
//						m_gridData[m][n].faceData[1].speed = speedV;
//					}
//					else
//					{
//						m_gridData[m][n].faceData[1].speed = speedT + (TotalData.density[m][n+1]-minDensity)
//							/(maxDensity-minDensity)*(speedV-speedT);
//					}
//				}
//				if(m-1>=0)
//				{
//					float speedT;
//					if(m_gridData[m][n].faceData[2].dheight<m_maxSlope 
//						||m_gridData[m][n].faceData[2].dheight>m_minSlope)
//						speedT = 0;
//					else speedT = m_maxSpeed + (m_gridData[m][n].faceData[2].dheight-m_minSlope)
//						/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//					float speedV =  -TotalData.averagev[m-1][n].x;
//					if(speedV<0) speedV = 0;
//					if(speedV>speedT) speedV=speedT;
//					if(TotalData.density[m-1][n]<=minDensity)
//					{
//						m_gridData[m][n].faceData[2].speed = speedT;
//					}
//					else if(TotalData.density[m-1][n]>=maxDensity)
//					{
//						m_gridData[m][n].faceData[2].speed = speedV;
//					}
//					else
//					{
//						m_gridData[m][n].faceData[2].speed = speedT + (TotalData.density[m-1][n]-minDensity)
//							/(maxDensity-minDensity)*(speedV-speedT);
//					}
//				}
//				if(n-1>=0)
//				{
//					float speedT;
//					if(m_gridData[m][n].faceData[3].dheight<m_maxSlope
//						||m_gridData[m][n].faceData[3].dheight>m_minSlope)
//						speedT = 0;
//					else speedT = m_maxSpeed + (m_gridData[m][n].faceData[3].dheight-m_minSlope)
//						/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//					float speedV =  -TotalData.averagev[m][n-1].z;
//					if(speedV<0) speedV = 0;
//					if(speedV>speedT) speedV=speedT;
//					if(TotalData.density[m][n-1]<=minDensity)
//					{
//						m_gridData[m][n].faceData[3].speed = speedT;
//					}
//					else if(TotalData.density[m][n-1]>=maxDensity)
//					{
//						m_gridData[m][n].faceData[3].speed = speedV;
//					}
//					else
//					{
//						m_gridData[m][n].faceData[3].speed = speedT + (TotalData.density[m][n-1]-minDensity)
//							/(maxDensity-minDensity)*(speedV-speedT);
//					}
//				}
//			}
//			for(int m=0;m<MAXgridX/*gridX*/;m++)
//				for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//				{
//					if(m+1<MAXgridX/*gridX*/)
//					{	
//						if(m_gridData[m][n].faceData[0].speed<=0) m_gridData[m][n].faceData[0].speed = MININT;
//						m_gridData[m][n].faceData[0].cost = (w1*m_gridData[m][n].faceData[0].speed+w2+
//							w3*m_gridData[m+1][n].discomfort)/m_gridData[m][n].faceData[0].speed;
//					}
//					if(n+1<MAXgridZ/*gridZ*/)
//					{
//						if(m_gridData[m][n].faceData[1].speed<=0) m_gridData[m][n].faceData[1].speed = MININT;
//						m_gridData[m][n].faceData[1].cost = (w1*m_gridData[m][n].faceData[1].speed+w2+
//							w3*m_gridData[m][n+1].discomfort)/m_gridData[m][n].faceData[1].speed;
//					}
//					if(m-1>=0)
//					{
//						if(m_gridData[m][n].faceData[2].speed<=0) m_gridData[m][n].faceData[2].speed = MININT;
//						m_gridData[m][n].faceData[2].cost = (w1*m_gridData[m][n].faceData[2].speed+w2+
//							w3*m_gridData[m-1][n].discomfort)/m_gridData[m][n].faceData[2].speed;
//					}
//					if(n-1>=0)
//					{
//						if(m_gridData[m][n].faceData[3].speed<=0) m_gridData[m][n].faceData[3].speed = MININT;
//						m_gridData[m][n].faceData[3].cost = (w1*m_gridData[m][n].faceData[3].speed+w2+
//							w3*m_gridData[m][n-1].discomfort)/m_gridData[m][n].faceData[3].speed;
//					}
//				}
//}
//void Potential::FMM()
//{
//	FMMArrayUnit Accept[MAXgridX*MAXgridZ];
//	FMMArrayUnit Near[MAXgridX*MAXgridZ];
//	FMMArrayUnit Far[MAXgridX*MAXgridZ];
//	int AcceptIndex = 0;
//	int NearIndex = 0;
//	int FarIndex = 0;
//	//initial
//	for(int m=0;m<MAXgridX/*gridX*/;m++)
//		for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//		{
//			m_gridData[m][n].FMMFlag = FMMFAR;
//			m_gridData[m][n].potential = MAXINT;
//		}
//
//		for(int m=m_GoalXa/**ratio*/;m<=m_GoalXb/**ratio*/;/*m+=interval*/m++)
//			for(int n=m_GoalZa/**ratio*/;n<=m_GoalZb/**ratio*/;/*n+=interval*/n++)
//			{
//				Accept[AcceptIndex].m = m;
//				Accept[AcceptIndex].n = n;
//				m_gridData[m][n].FMMFlag = FMMACCEPT;
//				m_gridData[m][n].potential = 0;
//				AcceptIndex++;
//			}
//			for(int i=0;i<AcceptIndex;i++)
//			{
//				int m = Accept[i].m;
//				int n = Accept[i].n;
//				if(m+1<MAXgridX/*gridX*/ && m_gridData[m+1][n].FMMFlag == FMMFAR)
//				{	
//					Near[NearIndex].m = m+1;
//					Near[NearIndex].n = n;
//					m_gridData[m+1][n].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(n+1<MAXgridZ/*gridZ*/ && m_gridData[m][n+1].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m;
//					Near[NearIndex].n = n+1;
//					m_gridData[m][n+1].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(m-1>=0&&m_gridData[m-1][n].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m-1;
//					Near[NearIndex].n = n;
//					m_gridData[m-1][n].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(n-1>=0&&m_gridData[m][n-1].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m;
//					Near[NearIndex].n = n-1;
//					m_gridData[m][n-1].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//			}
//			//loop
//			float temp[MAXgridX*MAXgridZ];
//			while(AcceptIndex<MAXgridX/*gridX*/*MAXgridZ/*gridZ*/)
//			{
//				for(int i=0;i<NearIndex;i++)
//				{
//					int m = Near[i].m;
//					int n = Near[i].n;
//					temp[i] = MAXINT;
//					if(m+1<MAXgridX/*gridX*/ && m_gridData[m+1][n].FMMFlag == FMMACCEPT && 
//						m_gridData[m+1][n].potential+m_gridData[m+1][n].faceData[2].cost<temp[i])
//						temp[i] = m_gridData[m+1][n].potential+m_gridData[m+1][n].faceData[2].cost;
//					if(n+1<MAXgridZ/*gridZ*/ && m_gridData[m][n+1].FMMFlag == FMMACCEPT &&
//						m_gridData[m][n+1].potential+m_gridData[m][n+1].faceData[3].cost<temp[i])
//						temp[i] = m_gridData[m][n+1].potential+m_gridData[m+1][n].faceData[3].cost;
//					if(m-1>=0&&m_gridData[m-1][n].FMMFlag == FMMACCEPT &&
//						m_gridData[m-1][n].potential+m_gridData[m-1][n].faceData[0].cost<temp[i])
//						temp[i] = m_gridData[m-1][n].potential+m_gridData[m-1][n].faceData[1].cost;
//					if(n-1>=0&&m_gridData[m][n-1].FMMFlag == FMMACCEPT &&
//						m_gridData[m][n-1].potential+m_gridData[m][n-1].faceData[1].cost<temp[i])
//						temp[i] = m_gridData[m][n-1].potential+m_gridData[m][n-1].faceData[1].cost;
//				}
//				float minNear = MAXINT;
//				int minIndex = 0;
//				for(int i=0;i<NearIndex;i++)
//				{
//					if(temp[i]<minNear)
//					{
//						minNear = temp[i];
//						minIndex = i;
//					}
//				}
//				int m = Near[minIndex].m;
//				int n = Near[minIndex].n;
//				int minm,minn;
//				argmin(m,n,minm,minn);
//				float a,b,c,d;
//				a = m_gridData[m+minm][n].potential;
//				b = m_gridData[m][n].faceData[1-minm].cost;
//				c = m_gridData[m][n+minn].potential;
//				d = m_gridData[m][n].faceData[2-minn].cost;
//				if(minm==0)
//					m_gridData[m][n].potential = sqrt(d)+c;
//				else if(minn==0)
//					m_gridData[m][n].potential = sqrt(b)+a;
//				else
//				{
//					float A = d + b;
//					float B = -2*a*d-2*c*b;
//					float C = a*a*d+c*c*b-b*d;
//					float D = B*B-4*A*C;
//					if(D<0)
//					{
//						D = 0;
//					}
//					m_gridData[m][n].potential = (-B+sqrt(D))/(2.0*A);
//					//m_gridData[m][n].potential = max(max(a,c),m_gridData[m][n].potential);
//				}
//				Accept[AcceptIndex].m = m;
//				Accept[AcceptIndex].n = n;
//				m_gridData[m][n].FMMFlag = FMMACCEPT;
//				AcceptIndex++;
//				for(int i=minIndex;i<NearIndex-1;i++)
//				{
//					Near[i].m = Near[i+1].m;
//					Near[i].n = Near[i+1].n;
//				}
//				NearIndex--;
//				if(m+1<MAXgridX/*gridX*/ && m_gridData[m+1][n].FMMFlag == FMMFAR)
//				{	
//					Near[NearIndex].m = m+1;
//					Near[NearIndex].n = n;
//					m_gridData[m+1][n].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(n+1<MAXgridZ/*gridZ*/ && m_gridData[m][n+1].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m;
//					Near[NearIndex].n = n+1;
//					m_gridData[m][n+1].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(m-1>=0&&m_gridData[m-1][n].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m-1;
//					Near[NearIndex].n = n;
//					m_gridData[m-1][n].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//				if(n-1>=0&&m_gridData[m][n-1].FMMFlag == FMMFAR)
//				{
//					Near[NearIndex].m = m;
//					Near[NearIndex].n = n-1;
//					m_gridData[m][n-1].FMMFlag = FMMNEAR;
//					NearIndex++;
//				}
//			}
//}
//Vec3f Potential::GetVelocity(Vec3f position, Vec3f front, bool flag ,TotalDataStruct & TotalData)
//{
//	float x = (position.x+gridX/2.0)/GRIDL;
//	float z = (position.z+gridZ/2.0)/GRIDL;
//	int m = floor(x/**ratio*/);
//	int n = floor(z/**ratio*/);
//	if(m_gridData[m][n].potential == 0) return(Vec3f(0,0,0));
//	float potentialm,potentialn;
//	if(m+1>=MAXgridX/*gridX*/)	
//		potentialm = m_gridData[m][n].potential - m_gridData[m-1][n].potential;
//	else if(m-1<0)
//		potentialm = m_gridData[m+1][n].potential - m_gridData[m][n].potential;
//	else
//		potentialm = (m_gridData[m+1][n].potential - m_gridData[m-1][n].potential)/2.0;
//	if(n+1>=MAXgridZ/*gridZ*/)
//		potentialn = m_gridData[m][n].potential - m_gridData[m][n-1].potential;
//	else if(n-1<0)
//		potentialn = m_gridData[m][n+1].potential - m_gridData[m][n].potential;
//	else
//		potentialn = (m_gridData[m][n+1].potential - m_gridData[m][n-1].potential)/2.0;
//	Vec3f potentialv = potentialm*Vec3f(1,0,0)+potentialn*Vec3f(0,0,1);
//	potentialv = normalized(- potentialv);
//	float speed =0;
//	int nextm,nextn;
//	Vec3f nextv = Vec3f(x,0,z) + potentialv;
//	nextm = floor(nextv.x/**ratio*/);
//	nextn = floor(nextv.z/**ratio*/);
//	float slope;
//	if(nextm==m&&nextn==n)
//	{
//		if(potentialv.x>0) nextm = nextm+1;
//		else if(potentialv.x<0) nextm = nextm-1;
//		if(potentialv.z>0) nextn = nextn+1;
//		else if(potentialv.z<0) nextn = nextn-1;
//	}
//	slope = (TotalData.height[m][n]-TotalData.height[nextm][nextn])/(sqrt((float)((nextm-m)*(nextm-m) + (nextn-n)*(nextn-n))));
//	float speedT = m_maxSpeed + (slope-m_minSlope)
//		/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//	if(slope>m_minSlope||slope<m_maxSlope) speedT = 0;
//	float speedV =  TotalData.averagev[nextm][nextn].dot(potentialv);
//	if(speedV<0) speedV = 0;
//	if(speedV>speedT) speedV=speedT;
//	float d = TotalData.density[nextm][nextn];
//	if(d<=minDensity)
//		speed = speedT;
//	else if(d>=maxDensity)
//		speed = speedV;
//	else
//		speed = speedT + (d-minDensity)/(maxDensity-minDensity)*(speedV-speedT);
//	if(speedT==0) speed = 0;
//	Vec3f velocity = speed*potentialv;
//
//	if(velocity.y!=0)
//	{
//		velocity.y = 0;
//	}
//	if(nextm>=MAXgridX/*gridX*/ || nextm<0) velocity.x = 0;
//	if(nextn>=MAXgridZ/*gridZ*/ || nextn<0) velocity.z = 0;
//
//	if(flag && front.dot(velocity)<0) 
//	{
//		velocity = velocity-(velocity.parallelComponent(front));
//	}
//	return velocity;
//
//}
//Vec3f Potential::GetAveVelocity(Vec3f position, Vec3f front, bool flag ,TotalDataStruct & TotalData)
//{
//	float x = (position.x+gridX/2.0)/GRIDL;
//	float z = (position.z+gridZ/2.0)/GRIDL;
//	int m = floor(x/**ratio*/);
//	int n = floor(z/**ratio*/);
//	if(m_gridData[m][n].ave_potential == 0) return(Vec3f(0,0,0));
//	float potentialm,potentialn;
//	if(m+1>=MAXgridX/*gridX*/)	
//		potentialm = m_gridData[m][n].ave_potential - m_gridData[m-1][n].ave_potential;
//	else if(m-1<0)
//		potentialm = m_gridData[m+1][n].ave_potential - m_gridData[m][n].ave_potential;
//	else
//		potentialm = (m_gridData[m+1][n].ave_potential - m_gridData[m-1][n].ave_potential)/2.0;
//	if(n+1>=MAXgridZ/*gridZ*/)
//		potentialn = m_gridData[m][n].ave_potential - m_gridData[m][n-1].ave_potential;
//	else if(n-1<0)
//		potentialn = m_gridData[m][n+1].ave_potential - m_gridData[m][n].ave_potential;
//	else
//		potentialn = (m_gridData[m][n+1].ave_potential - m_gridData[m][n-1].ave_potential)/2.0;
//	Vec3f potentialv = potentialm*Vec3f(1,0,0)+potentialn*Vec3f(0,0,1);
//	potentialv = -potentialv.normalize();
//	float speed =0;
//	int nextm,nextn;
//	Vec3f nextv = Vec3f(x,0,z) + potentialv;
//	nextm = floor(nextv.x/**ratio*/);
//	nextn = floor(nextv.z/**ratio*/);
//	float slope;
//	if(nextm==m&&nextn==n)
//	{
//		if(potentialv.x>0) nextm = nextm+1;
//		else if(potentialv.x<0) nextm = nextm-1;
//		if(potentialv.z>0) nextn = nextn+1;
//		else if(potentialv.z<0) nextn = nextn-1;
//	}
//	slope = (TotalData.height[m][n]-TotalData.height[nextm][nextn])/(sqrt((float)((nextm-m)*(nextm-m) + (nextn-n)*(nextn-n))));
//	float speedT = m_maxSpeed + (slope-m_minSlope)
//		/(m_maxSlope-m_minSlope)*(m_minSpeed - m_maxSpeed);
//	if(slope>m_minSlope||slope<m_maxSlope) speedT = 0;
//	float speedV =  TotalData.averagev[nextm][nextn].dot(potentialv);
//	if(speedV<0) speedV = 0;
//	if(speedV>speedT) speedV=speedT;
//	float d = TotalData.density[nextm][nextn];
//	if(d<=minDensity)
//		speed = speedT;
//	else if(d>=maxDensity)
//		speed = speedV;
//	else
//		speed = speedT + (d-minDensity)/(maxDensity-minDensity)*(speedV-speedT);
//	if(speedT==0) speed = 0;
//	Vec3 velocity = speed*potentialv;
//
//	if(velocity.y!=0)
//	{
//		velocity.y = 0;
//	}
//	if(nextm>=MAXgridX/*gridX*/ || nextm<0) velocity.x = 0;
//	if(nextn>=MAXgridZ/*gridZ*/ || nextn<0) velocity.z = 0;
//
//	if(flag && front.dot(velocity)<0) 
//	{
//		velocity = velocity-(velocity.parallelComponent(front));
//	}
//	return velocity;
//
//}
//void Potential::argmin(int m,int n,int &minm,int &minn)
//{
//	if(m-1<0 && m_gridData[m+1][n].FMMFlag == FMMACCEPT) minm = 1;
//	else if(m-1<0 && m_gridData[+1][n].FMMFlag != FMMACCEPT) minm = 0;
//	else if(m==MAXgridX/*gridX*/-1 && m_gridData[m-1][n].FMMFlag == FMMACCEPT) 
//		minm = -1;
//	else if(m==MAXgridX/*gridX*/-1 && m_gridData[m-1][n].FMMFlag != FMMACCEPT) 
//		minm = 0;
//	else if(m_gridData[m-1][n].FMMFlag != FMMACCEPT && m_gridData[m+1][n].FMMFlag != FMMACCEPT) minm = 0;
//	else minm = m_gridData[m-1][n].potential+m_gridData[m-1][n].faceData[0].cost <
//		m_gridData[m+1][n].potential+m_gridData[m+1][n].faceData[2].cost ? -1:1;
//
//	if(n-1<0 && m_gridData[m][n+1].FMMFlag == FMMACCEPT) minn = 1;
//	else if(n-1<0 && m_gridData[m][n+1].FMMFlag != FMMACCEPT) minn = 0;
//	else if(n ==MAXgridZ/*gridZ*/-1 && m_gridData[m][n-1].FMMFlag == FMMACCEPT) minn = -1;
//	else if(n ==MAXgridZ/*gridZ*/-1 && m_gridData[m][n-1].FMMFlag != FMMACCEPT) minn = 0;
//	else if(m_gridData[m][n-1].FMMFlag != FMMACCEPT && m_gridData[m][n+1].FMMFlag != FMMACCEPT) minn = 0;
//	else minn = m_gridData[m][n-1].potential+m_gridData[m][n-1].faceData[1].cost <
//		m_gridData[m][n+1].potential+m_gridData[m][n+1].faceData[3].cost ? -1:1;
//
//}
void Potential::addDensity(Vec3f position, Vec3f velocity)
{
	float x = position[0];
	float y = position[1];
	float z = position[2];
	int i = floor(x + 0.5);
	int j = floor(y + 0.5);
	int k = floor(z + 0.5);

	//Ӧsection 4.1㷨
	if (i > gridX || j > gridY || k > gridZ || i < 0 || j < 0 || k < 0) return;

	float deltax = x - i + 0.5 * GRIDL;
	float deltay = y - j + 0.5 * GRIDL;
	float deltaz = z - k + 0.5 * GRIDL;
	float tmp;
	if (i > 0 && j > 0 && k < gridX)  //density A
	{
		tmp = min(1 - deltax, 1 - deltay, deltaz);
		tmp = pow(tmp, lamda);
		density[i - 1][j - 1][k] += tmp;
		averagev[i - 1][j - 1][k] += velocity * tmp;
	}
	if (i < gridX && j > 0 && k < gridZ) //density B
	{
		tmp = min(deltax, 1 - deltay, deltaz);
		tmp = pow(tmp, lamda);
		density[i][j - 1][k] += tmp;
		averagev[i][j - 1][k] += velocity * tmp;
	}
	if (i < gridX && j < gridY && k < gridZ) //density C
	{
		tmp = min(deltax, deltay, deltaz);
		tmp = pow(tmp, lamda);
		density[i][j][k] += tmp;
		averagev[i][j][k] += velocity * tmp;
	}
	if (i > 0 && j < gridY && k < gridZ) //density D
	{
		tmp = min(1 - deltax, deltay, deltaz);
		tmp = pow(tmp, lamda);
		density[i - 1][j][k] += tmp;
		averagev[i - 1][j][k] += velocity * tmp;
	}

	if (i > 0 && j > 0 && k > 0)  //density E
	{
		tmp = min(1 - deltax, 1 - deltay, 1 - deltaz);
		tmp = pow(tmp, lamda);
		density[i - 1][j - 1][k - 1] += tmp;
		averagev[i - 1][j - 1][k - 1] += velocity * tmp;
	}
	if (i < gridX && j > 0 && k > 0) //density F
	{
		tmp = min(deltax, 1 - deltay, 1 - deltaz);
		tmp = pow(tmp, lamda);
		density[i][j - 1][k - 1] += tmp;
		averagev[i][j - 1][k - 1] += velocity * tmp;
	}
	if (i < gridX && j < gridY && k > 0) //density G
	{
		tmp = min(deltax, deltay, deltaz);
		tmp = pow(tmp, lamda);
		density[i][j][k - 1] += tmp;
		averagev[i][j][k - 1] += velocity * tmp;
	}
	if (i > 0 && j < gridY && k > 0) //density H
	{
		tmp = min(1 - deltax, deltay, 1 - deltaz);
		tmp = pow(tmp, lamda);
		density[i - 1][j][k - 1] += tmp;
		averagev[i - 1][j][k - 1] += velocity * tmp;
	}
}

Vec3f Potential::get_gradient(Vec3f position)
{
	int i,j,k;
	float fx,fy,fz;
	Vec3f gradient;

	get_barycentric(position[0], i, fx, 0, gridX);
	get_barycentric(position[1], j, fy, 0, gridY);
	get_barycentric(position[2], k, fz, 0, gridZ);
	//dx
	float v000 = (density[i+1][j][k] - density[i-1][j][k]) / GRIDL * 0.5f;
	float v001 = (density[i+1][j][k+1] - density[i-1][j][k+1]) / GRIDL * 0.5f;
	float v010 = (density[i+1][j+1][k] - density[i-1][j+1][k]) / GRIDL*0.5f;
	float v011 = (density[i+1][j+1][k+1] - density[i-1][j+1][k+1]) / GRIDL * 0.5f;
	float v100 = (density[i+2][j][k] - density[i][j][k]) / GRIDL * 0.5f;
	float v101 = (density[i+2][j][k+1]-density[i][j][k+1]) / GRIDL * 0.5f;
	float v110 = (density[i+2][j+1][k]-density[i][j+1][k]) / GRIDL * 0.5f;
	float v111 = (density[i+2][j+1][k+1] - density[i][j+1][k+1]) / GRIDL * 0.5f;
	gradient[0]=trilerp(v000, v100, v010, v110, v001, v101, v011, v111, fx, fy, fz);
	//dy
	v000 = (density[i][j+1][k]-density[i][j-1][k])/GRIDL*0.5f;
	v001 = (density[i][j+1][k+1]-density[i][j-1][k+1])/GRIDL*0.5f;
	v010 = (density[i][j+2][k]-density[i][j][k])/GRIDL*0.5f;
	v011 = (density[i][j+2][k+1]-density[i][j][k+1])/GRIDL*0.5f;
	v100 = (density[i+1][j+1][k]-density[i+1][j-1][k])/GRIDL*0.5f;
	v101 = (density[i+1][j+1][k+1]-density[i+1][j-1][k+1])/GRIDL*0.5f;
	v110 = (density[i+1][j+2][k]-density[i+1][j][k])/GRIDL*0.5f;
	v111 = (density[i+1][j+2][k+1]-density[i+1][j][k+1])/GRIDL*0.5f;
	gradient[1]=trilerp(v000, v100,v010, v110, v001, v101,v011, v111,fx, fy, fz);
	//dz
	v000 = (density[i][j][k+1]-density[i][j][k-1])/GRIDL*0.5f;
	v001 = (density[i][j][k+2]-density[i][j][k])/GRIDL*0.5f;
	v010 = (density[i][j+1][k+1]-density[i][j+1][k-1])/GRIDL*0.5f;
	v011 = (density[i][j+1][k+2]-density[i][j+1][k])/GRIDL*0.5f;
	v100 = (density[i+1][j][k+1]-density[i+1][j][k-1])/GRIDL*0.5f;
	v101 = (density[i+1][j][k+2]-density[i+1][j][k])/GRIDL*0.5f;
	v110 = (density[i+1][j+1][k+1]-density[i+1][j+1][k-1])/GRIDL*0.5f;
	v111 = (density[i+1][j+1][k+2]-density[i+1][j+1][k])/GRIDL*0.5f;
	gradient[2]=trilerp(v000, v100,v010, v110, v001, v101,v011, v111,fx, fy, fz);

	return gradient;
}

//void Potential::addPotential()
//{
//	if(sum_num<MAXSUMNUM) sum_num++;
//	for(int m=0;m<MAXgridX/*gridX*/;m++)
//		for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//			m_gridData[m][n].p[sum_index] = m_gridData[m][n].potential;
//	sum_index++;
//	if(sum_index>=MAXSUMNUM) sum_index=0;
//	for(int m=0;m<MAXgridX/*gridX*/;m++)
//		for(int n=0;n<MAXgridZ/*gridZ*/;n++)
//		{
//			m_gridData[m][n].ave_potential = 0;
//			for(int i=0;i<sum_num;i++)
//				m_gridData[m][n].ave_potential += m_gridData[m][n].p[i];
//			m_gridData[m][n].ave_potential /= sum_num;
//		}
//}