//Potential.h

#pragma once

#ifndef _POTENTIAL_H_
#define _POTENTIAL_H_

#include "vec.h"

#define MAXgridX 40   
#define MAXgridY 40
#define	MAXgridZ 40
#define GRIDL 1
#define FMMACCEPT 0    
#define FMMNEAR 1       
#define FMMFAR 2
#define MININT 0.0001 
#define MAXINT 100000
#define MAXSUMNUM /*70*/500

typedef struct{
	int m;
	int n;
}FMMArrayUnit;

typedef struct{
	float speed;
	float cost;
	float dheight;
	float dpotential;
	Vec3f velocity;
}faceDataStruct;

typedef struct{ 
	float discomfort; 
	float potential;     
	//float p[MAXSUMNUM]; 
	float ave_potential;  
	faceDataStruct faceData[6]; 
	int FMMFlag;
}gridDataStruct;

typedef struct {
	float density[MAXgridX][MAXgridY][MAXgridZ];    
	Vec3f averagev[MAXgridX][MAXgridY][MAXgridZ];   
	float height[MAXgridX][MAXgridY][MAXgridZ];    
	float discomfort[MAXgridX][MAXgridY][MAXgridZ]; 
	int gridX;   
	int gridY;
	int gridZ;                            
}TotalDataStruct;

class Potential 
{
public :
	gridDataStruct m_gridData[MAXgridX][MAXgridY][MAXgridZ];
	float density[MAXgridX][MAXgridY][MAXgridZ]; 
	Vec3f averagev[MAXgridX][MAXgridY][MAXgridZ];  
	float discomfort[MAXgridX][MAXgridY][MAXgridZ]; 


	float m_maxSpeed;
	float m_minSpeed;
	float m_maxSlope;
	float m_minSlope;
	int m_GoalXa;
	int m_GoalXb;
	int m_GoalZa;
	int m_GoalZb;
	int gridX;
	int gridY;
	int gridZ;
	//

	float maxDensity;
	float minDensity;
	float lamda;
	float w1;
	float w2;
	float w3;
	int sum_index;
	int sum_num;
public :
	Potential(int x,int y,int z,float maxd,float mind,float _lamda,float m1,float m2,float m3);
	void SetGoal(int xa,int xb,int za,int zb);
	void SetSpeedRange(float minSpeed, float maxSpeed);
	void SetSlopeRange(float maxSlope, float minSlope);
	void ComputeFaceData(TotalDataStruct & TotalData);
	void FMM();
	Vec3f GetVelocity(Vec3f position,Vec3f front, bool flag , TotalDataStruct & TotalData);
	Vec3f GetAveVelocity(Vec3f position,Vec3f front, bool flag , TotalDataStruct & TotalData);
	void addDensity(Vec3f position,Vec3f velocity);
	void addPotential();
	Vec3f get_gradient(Vec3f position);
private:
	void argmin(int m,int n,int &minm,int &minn);

};

#endif