#include "app.h"
#include "Horde3D.h"
#include "Horde3DUtils.h"
#include <math.h>
#include <iomanip>
#include <GL\glut.h>
#include <cstdio>
#include <iostream>

#include "CIniReader.h"

extern CIniReader *fin = new CIniReader(".//config//aggregation2.ini");
extern FILE *fout;

// Ƕת
inline float degToRad( float f ) 
{
	return f * (3.1415926f / 180.0f);
}

Potential Particle::m_potential = Potential(20,20,20,0.45,0.01,1,1,6,2);

// ʼ
Application::Application( const std::string &appPath )
{
	for( unsigned int i = 0; i < 320; ++i )
	{	
		_keys[i] = false;
		_prevKeys[i] = false;
	}

	Vec3f pos = fin->ReadVec3f("view","pos"), ori = fin->ReadVec3f("view","ori");
	_x = pos[0];
	_y = pos[1];
	_z = pos[2];
	_rx = ori[0];
	_ry = ori[1];
	_rz = ori[2];
	_velocity = fin->ReadFloat("view","velocity");
	_curFPS = 25;
	display_timestep = 1 / _curFPS;
	simulation_timestep = 0.04;

	_statMode = 0;
	_freezeMode = 0; _debugViewMode = false; _wireframeMode = false;
	_cam = 0;
	memset(ct,0,sizeof(ct));
	frame = 0;
	junk = -1;

	_contentDir = appPath + "../Content";

}


bool Application::init()
{	
	// Initialize engine
	if( !h3dInit() )
	{	
		h3dutDumpMessages();
		return false;
	}

	//init_day();
	init_lamp();

	//================================
	// Init random generator
	//srand( (unsigned int)time( NULL ) );
	srand( 99777 );  // Use fixed value for better performance comparisons

	//ģͺͶ󶨵horde
	H3DRes characterRes = h3dAddResource( H3DResTypes::SceneGraph, "models/insect/insect.scene.xml", 0 );
	//H3DRes characterWalkRes = h3dAddResource( H3DResTypes::Animation, "animations/fly.anim", 0 );
	h3dutLoadResourcesFromDisk( _contentDir.c_str() );

	fout = fopen("traj-2.txt","w");

	//ҪĶĺ
	makenoise = new MakeNoise();
	//ô˺ӵ״̬ʼ
	makenoise->seed_particles(particles, 500);
	//fprintf(fout,"%d\n",500);


	//趨ʼĿĵأٶȷΧ¶ȷΧ
	gridX = Particle::m_potential.gridX;
	gridY = Particle::m_potential.gridY;
	gridZ = Particle::m_potential.gridZ;

	Particle::m_potential.SetGoal(gridX-2,gridX-1,0,gridZ-1);
	Particle::m_potential.SetSpeedRange(2.5,5.0);
	Particle::m_potential.SetSlopeRange(-2,2);

	for (iterator i = particles.begin(); i != particles.end(); i ++)
	{
		(*i).getVelocity();
		// Add character to scene and apply animation
		//ӵhorde3dĶ
		(*i).node = h3dAddNodes( H3DRootNode, characterRes );
		//Ӹ趯
		//ʼһֵʾ
		//h3dSetupModelAnimStage( (*i).node, 0, characterWalkRes, 0, "", false );
		//(*i).animTime = rand() % 60;

		//ӵĵǰλ
		//Ҫת
		h3dSetNodeTransform( (*i).node, (*i).Position[0], (*i).Position[1], (*i).Position[2], 0, 0, 0, 0.01, 0.01, 0.01);
	}

	return true;
}

//updateÿһ֡λá
void Application::update(float fps)
{
	if( ! _freezeMode )
	{
//---------------------begin---------continuum crowds㷨----------------------------------

		////ϵֵpotientaldiscomfortֵ
		//resetPotential();

		////ۼƼTotalDataеܶȺٶ section4.1е㷨
		//for (iterator i = particles.begin(); i != particles.end(); i++)
		//	(*i).updateDensity();

		//for(int x = 0; x < gridX; x ++)
		//	for (int y = 0; y < gridY; y ++)
		//		for(int z = 0; z < gridZ; z++)
		//		if(Particle::m_potential.density[x][y][z]>0) 
		//			Particle::m_potential.averagev[x][y][z] = Particle::m_potential.averagev[x][y][z]/Particle::m_potential.density[x][y][z];

		//ܳ
		//Particle::m_potential.ComputeFaceData(TotalData);
		//Particle::m_potential.FMM();

		// update, draw and annotate each agent
		//for (iterator i = particles.begin(); i != particles.end(); i ++)
		//	(*i).getGlobalVelocity ();	

//---------------------end-----------continuum crowds㷨----------------------------------

		//fprintf(fout,"frame #%d\n", frame++);

		Vec3f midx;

		//for( unsigned int j = tracelength - 1; j > 0; -- j )
		//	_particles[j] = _particles[j-1];

		display_timestep = 1 / fps;
		//ӵٶֵӵĵǰλãnoise_velocity
		iterator i;
		int j = 0;
		for (i = particles.begin(); i != particles.end(); i ++, j ++)
		{
			// almost RK2 (not updating t halfway through time step, so it's technically only 1st order accurate)
			makenoise -> get_velocity( (*i).Position, (*i).noise_velocity );
			midx =(*i).Position + 0.5f * simulation_timestep * (*i).getVelocity();
			makenoise -> get_velocity( midx, (*i).noise_velocity );
			//λóİ뾶ٶȵķOPͬ͸ıٶȷ
			//Vec3f tmp = (*i).Position;
			//tmp[2] -= 4.5;
			//if ((mag2(tmp) > 4.0) && (dot(tmp, (*i).noise_velocity) > 0.0))
			//	(*i).noise_velocity = - (*i).noise_velocity;

			float matrix1[4][4] = {{1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1}};
			float matrix2[4][4] = {{1,0,0,0}, {0,1,0,0}, {0,0,1,0}, {0,0,0,1}};
			Vec3f v = (*i).getVelocity();
			float x = v[0], y = v[1], z = v[2];
			float d = sqrt(x*x+y*y+z*z);
			if (d > 0.000001) //Ϊ0κβ
			{
				x = x/d;
				y = y/d;
				z = z/d;

				d = sqrt(x*x+z*z);
				if (d > 0.000001)
				{
					float cosbeta =x/d, sinbeta = z/d ;

					//matrix1[4][4]ĳͷxᣬΪyϵyתbetaǶȡbetaxyzxozƽϵͶӰx֮ļн
					matrix1[0][0] = cosbeta;
					matrix1[0][2] = sinbeta;
					matrix1[2][0] = -sinbeta;
					matrix1[2][2] = cosbeta;
				}

				//matrix2[4][4]ʼΪλȻΪxyz루xyzxozƽϵͶӰĲˣע˳򣡣
				//ͷȥʱתxyzxozƽϵͶӰ루xyz֮ĽǶtheta
				if (x == 0 && z == 0)
				{
					Rotate(0,1,0,0,-y/abs(y),matrix2);
				}
				else
				{
					float nx = y * z ,ny = 0,nz = - x * y;
					d = sqrt(nx*nx+ny*ny+nz*nz);

					if (d > 0.000001)
					{
						nx = nx/d;
						ny = ny/d;
						nz = nz/d;
						float costheta=sqrt(x*x+z*z), sintheta = abs(y);
						Rotate(costheta, sintheta, nx, ny, nz, matrix2);
					}
				}
			}

			float matrix[4][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}};
			float matrix3[4][4] = {{0.02,0,0,0},{0,0.02,0,0},{0,0,0.02,0},{0,0,0,1}};
			float matrix4[4][4] = {{0,0,0,0}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}};
			Muti(matrix4,matrix3,matrix1);
			Muti(matrix, matrix4, matrix2);

			Vec3f position = (*i).Position;
			matrix[3][0] = position[0]/8, matrix[3][1] = position[1]/8, matrix[3][2] = position[2]/8;
			h3dSetNodeTransMat((*i).node, (const float *)matrix);
			//(*i).animTime += 1.8f;
			//h3dSetModelAnimParams((*i).node, 0, (*i).animTime, 1.0f);
			(*i).Position += simulation_timestep * (*i).getVelocity();

			//if (frame > 25)
			//fprintf(fout,"%.3f %.3f %.3f %.3f %.3f %.3f\n",position[0],position[1],position[2], (*i).velocity[0], (*i).velocity[1], (*i).velocity[2]);
		}
		//iterator i = particles.begin();
		//printf("%.3f,%.3f,%.3f ----------",(*i).global_velocity[0],(*i).global_velocity[1],(*i).global_velocity[2]);
		//printf(" %.3f,%.3f,%.3f \n",(*i).Position[0],(*i).Position[1],(*i).Position[2]);
		//psi
		makenoise -> advance_time( simulation_timestep );
	}
}

void Application::resetPotential(void)
{
	for(int x = 0; x < gridX; x ++)
		for (int y = 0; y < gridY; y ++)
			for(int z = 0; z < gridZ; z ++)
			{
				Particle::m_potential.density[x][y][z] = 0;
				Particle::m_potential.averagev[x][y][z] = Vec3f(0,0,0);
				Particle::m_potential.m_gridData[x][y][z].discomfort = 0;
			}
			
}

void Application::Muti( float matrix[4][4], float matrix1[4][4], float matrix2[4][4])
{

	for (int i = 0; i < 4; i ++)
		for (int j = 0; j < 4; j ++)
			for (int k = 0; k < 4; k ++)
				matrix[i][j] += matrix1[i][k] * matrix2[k][j];
	return;
}

void Application::Rotate( float costheta, float sintheta, float nx, float ny, float nz, float matrix[4][4] )
{
	//nx,ny,nzΪ n׼
	//matrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1); //ʼ

	matrix[0][0] = nx * nx * ( 1 - costheta ) + costheta;
	matrix[0][1] = nx * ny * ( 1 - costheta ) - nz * sintheta;
	matrix[0][2] = nx * nz * ( 1 - costheta ) + ny * sintheta;
	matrix[1][0] = nx * ny * ( 1 - costheta ) + nz * sintheta;
	matrix[1][1] = ny * ny * ( 1 - costheta ) + costheta;
	matrix[1][2] = ny * nz * ( 1 - costheta ) - nx * sintheta;
	matrix[2][0] = nx * nz * ( 1 - costheta ) - ny * sintheta;
	matrix[2][1] = ny * nz * ( 1 - costheta ) + nx * sintheta;
	matrix[2][2] = nz * nz * ( 1 - costheta ) + costheta;  
	return;
}
void Application::init_lamp()
{	
	// Set options
	h3dSetOption( H3DOptions::LoadTextures, 1 );
	h3dSetOption( H3DOptions::TexCompression, 0 );
	h3dSetOption( H3DOptions::MaxAnisotropy, 4 );
	h3dSetOption( H3DOptions::ShadowMapSize, 2048 );
	h3dSetOption( H3DOptions::FastAnimation, 1 );

	// Add resources Щòʡƹ⡢ʾģʽȣԲø
	// Pipelines
	_forwardPipeRes = h3dAddResource( H3DResTypes::Pipeline, "pipelines/forward.pipeline.xml", 0 );
	_deferredPipeRes = h3dAddResource( H3DResTypes::Pipeline, "pipelines/deferred.pipeline.xml", 0 );
	// Overlays
	_fontMatRes = h3dAddResource( H3DResTypes::Material, "overlays/font.material.xml", 0 );
	_panelMatRes = h3dAddResource( H3DResTypes::Material, "overlays/panel.material.xml", 0 );
	// Shader for deferred shading
	H3DRes lightMatRes = h3dAddResource( H3DResTypes::Material, "materials/light.material.xml", 0 );
	// Environment
	H3DRes envRes = h3dAddResource( H3DResTypes::SceneGraph, "models/platform/platform.scene.xml", 0 );
	// Skybox
	H3DRes skyBoxRes = h3dAddResource( H3DResTypes::SceneGraph, "models/sky02/sky02.scene.xml", 0 );

	// Load resources
	h3dutLoadResourcesFromDisk( _contentDir.c_str() );

	// Add scene nodes
	// Add camera
	_cam = h3dAddCameraNode( H3DRootNode, "Camera", _forwardPipeRes );
	h3dSetNodeParamI( _cam, H3DCamera::OccCullingI, 1 );

	// Add environment
	H3DNode env = h3dAddNodes( H3DRootNode, envRes );
	h3dSetNodeTransform( env, 0, -2, 0, 0, 0, 0, 0.23f, 0.23f, 0.23f );

	// Add skybox
	H3DNode sky = h3dAddNodes( H3DRootNode, skyBoxRes );
	h3dSetNodeTransform( sky, 0, -2, 0, 0, 0, 0, 0.003, 0.003, 0.003 );
	h3dSetNodeFlags( sky, H3DNodeFlags::NoCastShadow, true );

	// Add light source
	//ģ䣬棬ϿգǶ180ȣûӰ
	H3DNode light = h3dAddLightNode( H3DRootNode, "Light1", lightMatRes, "LIGHTING", "SHADOWMAP" );
	h3dSetNodeTransform(light, 0, 80, 0, -90, 0, 0, 1, 1, 1 );  //߶80ģ͵ĴС
	h3dSetNodeParamF( light, H3DLight::RadiusF, 0, 2100 );
	h3dSetNodeParamF( light, H3DLight::FovF, 0, 180 );
	h3dSetNodeParamI( light, H3DLight::ShadowMapCountI, 0 );
	h3dSetNodeParamF( light, H3DLight::ShadowSplitLambdaF, 0, 0.5f );
	h3dSetNodeParamF( light, H3DLight::ShadowMapBiasF, 0, 0.001f );
	h3dSetNodeParamF( light, H3DLight::ColorF3, 0, 0.5f );
	h3dSetNodeParamF( light, H3DLight::ColorF3, 1, 0.5f );
	h3dSetNodeParamF( light, H3DLight::ColorF3, 2, 0.5f );

	//add light 2------------------------ 
	//ģֱ̫䣬Ƕ-70
	H3DNode light1 = h3dAddLightNode( H3DRootNode, "Light2", lightMatRes, "LIGHTING", "SHADOWMAP" );
	h3dSetNodeTransform(light1, 0, 60, 40, -70, 0, 0, 1, 1, 1 );//߶80
	h3dSetNodeParamF( light1, H3DLight::RadiusF, 0, 2100 );
	h3dSetNodeParamF( light1, H3DLight::FovF, 0, 90 );
	h3dSetNodeParamI( light1, H3DLight::ShadowMapCountI, 3);
	h3dSetNodeParamF( light1, H3DLight::ShadowSplitLambdaF, 0, 0.9f );
	h3dSetNodeParamF( light1, H3DLight::ShadowMapBiasF, 0, 0.001f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 0, 0.6f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 1, 0.6f );
	h3dSetNodeParamF( light1, H3DLight::ColorF3, 2, 0.6f );

	//add light 3
	//ģ䣬
	H3DNode light2 = h3dAddLightNode( H3DRootNode, "Light3", lightMatRes, "LIGHTING", "SHADOWMAP" );
	h3dSetNodeTransform(light2, 0, 0, 0, 90, 0, 0, 1, 1, 1 );//(light1, 485, 50, 852, -90, 0, 80, 1, 1, 1 );
	h3dSetNodeParamF( light2, H3DLight::RadiusF, 0, 1000 );
	h3dSetNodeParamF( light2, H3DLight::FovF, 0, 250 );
	h3dSetNodeParamI( light2, H3DLight::ShadowMapCountI, 0);
	h3dSetNodeParamF( light2, H3DLight::ShadowSplitLambdaF, 0, 0.9f );
	h3dSetNodeParamF( light2, H3DLight::ShadowMapBiasF, 0, 0.001f );
	h3dSetNodeParamF( light2, H3DLight::ColorF3, 0, 0.9f );
	h3dSetNodeParamF( light2, H3DLight::ColorF3, 1, 0.9f );
	h3dSetNodeParamF( light2, H3DLight::ColorF3, 2, 0.9f );

}


//ȾԲø
void Application::mainLoop( float fps )
{
	_curFPS = fps;

	h3dSetOption( H3DOptions::DebugViewMode, _debugViewMode ? 1.0f : 0.0f );
	h3dSetOption( H3DOptions::WireframeMode, _wireframeMode ? 1.0f : 0.0f );

	if( !_freezeMode )
	{
		update( _curFPS );
	}

	// Set camera parameters
	h3dSetNodeTransform( _cam, _x, _y, _z, _rx ,_ry, 0, 1, 1, 1 );

	// Show stats
	h3dutShowFrameStats( _fontMatRes, _panelMatRes, _statMode );
	if( _statMode > 0 )
	{
		if( h3dGetNodeParamI( _cam, H3DCamera::PipeResI ) == _forwardPipeRes )
			h3dutShowText( "Pipeline: forward", 0.03f, 0.24f, 0.026f, 1, 1, 1, _fontMatRes );
		else
			h3dutShowText( "Pipeline: deferred", 0.03f, 0.24f, 0.026f, 1, 1, 1, _fontMatRes );
	}

	// Render scene
	h3dRender( _cam );

	// Finish rendering of frame
	h3dFinalizeFrame();

	// Remove all overlays
	h3dClearOverlays();

	// Write all messages to log file
	h3dutDumpMessages();
}

void Application::release()
{
	//int i,j;
	//for (i=0;i<54;i++)
	//{
	//	for(j=0;j<50;j++)
	//	{
	//		printf("%.3f %.3f %.3f  ", store[i][j][0], store[i][j][1], store[i][j][2]);
	//	}
	//	printf("\n");
	//}

	delete makenoise; 
	makenoise = 0x0; 

	//for (iterator i = particles.begin(); i != particles.end(); i ++)
	//	delete(i);
	particles.clear();

	// Release engine
	h3dRelease();
}


void Application::resize( int width, int height )
{
	// Resize viewport
	h3dSetNodeParamI( _cam, H3DCamera::ViewportXI, 0 );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportYI, 0 );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportWidthI, width );
	h3dSetNodeParamI( _cam, H3DCamera::ViewportHeightI, height );
	
	// Set virtual camera parameters
	h3dSetupCameraView( _cam, 45.0f, (float)width / height, 0.1f, 1000.0f );
	h3dResizePipelineBuffers( _deferredPipeRes, width, height );
	h3dResizePipelineBuffers( _forwardPipeRes, width, height );
}


void Application::keyStateHandler()
{
	// ----------------
	// Key-press events
	// ----------------
	if( _keys[32] && !_prevKeys[32] )  // Space
	{
		if( ++_freezeMode == 3 ) _freezeMode = 0;
	}
	
	if( _keys[260] && !_prevKeys[260] )  // F3
	{
		if( h3dGetNodeParamI( _cam, H3DCamera::PipeResI ) == _forwardPipeRes )
			h3dSetNodeParamI( _cam, H3DCamera::PipeResI, _deferredPipeRes );
		else
			h3dSetNodeParamI( _cam, H3DCamera::PipeResI, _forwardPipeRes );
	}
	
	if( _keys[264] && !_prevKeys[264] )  // F7
		_debugViewMode = !_debugViewMode;

	if( _keys[265] && !_prevKeys[265] )  // F8
		_wireframeMode = !_wireframeMode;
	
	if( _keys[263] && !_prevKeys[263] )  // F6
	{
		_statMode += 1;
		if( _statMode > H3DUTMaxStatMode ) _statMode = 0;
	}

	// --------------
	// Keya----------
	if( _freezeMode != 2 )
	{
		float curVel = _velocity / _curFPS;
		
		if( _keys[287] ) curVel *= 5;	// LShift
		
		if( _keys['W'] )
		{
			// Move forward
			_x -= sinf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
			_y -= sinf( -degToRad( _rx ) ) * curVel;
			_z -= cosf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
		}
		if( _keys['S'] )
		{
			// Move backward
			_x += sinf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
			_y += sinf( -degToRad( _rx ) ) * curVel;
			_z += cosf( degToRad( _ry ) ) * cosf( -degToRad( _rx ) ) * curVel;
		}
		if( _keys['A'] )
		{
			// Strafe left
			_x += sinf( degToRad( _ry - 90) ) * curVel;
			_z += cosf( degToRad( _ry - 90 ) ) * curVel;
		}
		if( _keys['D'] )
		{
			// Strafe right
			_x += sinf( degToRad( _ry + 90 ) ) * curVel;
			_z += cosf( degToRad( _ry + 90 ) ) * curVel;
		}
	}
}


void Application::mouseMoveEvent( float dX, float dY )
{
	if( _freezeMode == 2 ) return;
	
	// Look left/right
	_ry -= dX / 100 * 30;
	
	// Loop up/down but only in a limited range
	_rx += dY / 100 * 30;
	if( _rx > 90 ) _rx = 90; 
	if( _rx < -90 ) _rx = -90;
}
